mui.init({
	swipeBack:true //启用右滑关闭功能
});

// 刷新列表页
function refreshListPage(){
	var list = plus.webview.getWebviewById('addrList.html');
	mui.fire(list,'refresh');
}

function inputBlur(){
	$("input,textarea").blur();
}
var addr,addrDetail,receiveMan,receivePhone,isDefault=1,isSend = false;
var addrId = $.getUrlParam("id");
(function($, doc) {
		$.init();
		$.ready(function() {
			/**
			 * 获取对象属性的值
			 * 主要用于过滤三级联动中，可能出现的最低级的数据不存在的情况，实际开发中需要注意这一点；
			 * @param {Object} obj 对象
			 * @param {String} param 属性名
			 */
			var _getParam = function(obj, param) {
				return obj[param] || '';
			};
			
			//					//级联示例
			var cityPicker3 = new $.PopPicker({
				layer: 3
			});
			cityPicker3.setData(cityData3);
			var showCityPickerButton = doc.getElementById('showCityPicker3');
			var cityResult3 = doc.getElementById('cityResult3');
			showCityPickerButton.addEventListener('tap', function(event) {
				console.log("点击选择栏目");
				inputBlur();
				cityPicker3.show(function(items) {
					cityResult3.value = "" + _getParam(items[0], 'text') + "·" + _getParam(items[1], 'text') + "·" + _getParam(items[2], 'text');
					addr = _getParam(items[0], 'text')+_getParam(items[1], 'text')+_getParam(items[2], 'text');
					console.log("省市区地址："+addr);
					//返回 false 可以阻止选择框的关闭
					//return false;
				});
			}, false);
		});
})(mui, document);

// 设置默认
$('.default-box').on('touchend',function(e){
	e.preventDefault();
	inputBlur();
	if($(this).hasClass("seTdefault")){  // 不默认
		isDefault = 0;
		$(this).find("img").attr("src","images/icon_unchecked@2x.png");
		$(this).removeClass("seTdefault");
	}else{ // 默认
		isDefault = 1;
		$(this).find("img").attr("src","images/icon_selection@2x.png");
		$(this).addClass("seTdefault");
	}
});

hide_position_button();

// 保存点击
$('#save').on('touchend',function(e){
	e.preventDefault();
	
	$("input,textarea").blur();
	
	receiveMan = $("#receiveMan").val();
	receivePhone = $("#receivePhone").val();
	addrDetail = $("#addrDetail").val();
	if(!receiveMan){
		toast_adhoc("请填写收件人");
		return false;
	}else if(!receivePhone){
		toast_adhoc("请填写收件人手机号码");
		return false;
	}else if(receivePhone.length != 11){
		toast_adhoc("请填写11位数手机号码");
		return false;
	}else if(!addr){
		toast_adhoc("请选择省市区");
		return false;
	}else if(!addrDetail){
		toast_adhoc("请填写详细地址");
		return false;
	}
	
	if(addrId){
		updateUserAddr();
	}else{
		insertAddr();
	}
	
});

// 提交地址
function insertAddr(){
	isSend = true;
	var ticket = localStorage.getItem("ticket");
	var url =  urlPre + "user/insertAddr";
	mui.ajax(url,{
    	data:{
    		ticket:ticket,
    		addr:addr,
    		addrDetail:addrDetail,
    		receiveMan:receiveMan,
    		receivePhone:receivePhone,
    		isDefault:isDefault
		},
	    dataType:'json',
	    type:'GET',
	    //timeout:20000,
		success:function(res){
			isSend = false;
			if(res.code == 200){
				mui.toast('添加地址成功');
				refreshListPage();
				plus.webview.currentWebview().close();
			}else{
				mui.toast('添加失败,原因:'+res.msg);
			}
		},error : function(){
			isSend = false;
		}
	});
}

// 是否编辑
if(addrId){
	$("#nav-title").html("编辑收货地址");
	getUserAddr();
}
// 获取收货地址
function getUserAddr(){
	var ticket = localStorage.getItem("ticket");
	var url =  urlPre + "user/getUserAddr";
	mui.ajax(url,{
    	data:{
    		ticket:ticket,
    		isDefault:0
		},
	    dataType:'json',
	    type:'GET',
		success:function(res){
			if(res.code == 200){
				$.each(res.data,function(key,value){
					if(value.id == addrId){
						$("#receiveMan").val(value.receiveMan);
						$("#receivePhone").val(value.receivePhone);
						$("#cityResult3").val(value.addr);
						$("#addrDetail").val(value.addrDetail);
						addr = $("#cityResult3").val();
					}
				});
			}else{
				mui.toast('获取,原因:'+res.msg);
			}
		}
	});
}
// 更新收货地址
function updateUserAddr(){
	var ticket = localStorage.getItem("ticket");
	var url =  urlPre + "user/updateUserAddr";
	mui.ajax(url,{
    	data:{
    		ticket:ticket,
    		id:addrId,
    		addr:addr,
    		addrDetail:addrDetail,
    		receiveMan:receiveMan,
    		receivePhone:receivePhone,
    		isDefault:isDefault
		},
	    dataType:'json',
	    type:'POST',
		success:function(res){
			if(res.code == 200){
				mui.toast('修改成功');
				refreshListPage();
				plus.webview.currentWebview().close();
			}else{
				mui.toast('修改失败,原因:'+res.msg);
			}
		}
	});
}
