(function($, doc) {
var MIN_SOUND_TIME = 800;
var targetId, targetType;
var imageViewer = null;
$.init({
	beforeback: function() {  // 屏蔽返回				  
		if(document.querySelector(".mui-imageviewer-item")){
			imageViewer.viewer.style.opacity = 0;  
			setTimeout(function() {  
			    imageViewer.viewer.style.display = 'none';  
			    imageViewer.disposeImage(true);  
			}, 300);  			 
			return false;
		}else{  //返回true，继续页面关闭逻辑
			//closeDatabase(); //关闭数据库
			return true;
		}		
	},
	gestureConfig: {
		tap: true, //默认为true
		doubletap: true, //默认为false
		longtap: true, //默认为false
		swipe: true, //默认为true
		drag: true, //默认为true
		hold: true, //默认为false，不监听
		release: true //默认为false，不监听
	}
});
template.config('escape', false);
 
var needAvatar = null, needNickname=null; //群组头像
 
if(mui.os.ios){
	// 解决在ios上fixed元素focusin时位置出现错误的问题 
	document.addEventListener('DOMContentLoaded',function(){
		var footerDom = document.querySelector('footer');
		
		document.addEventListener('focusin', function() {
			footerDom.style.position = 'absolute';
		});
		document.addEventListener('focusout', function() {
			footerDom.style.position = 'fixed';
		});
	});
}
 

$.plusReady(function() {
 
	//openDB();//打开数据库
	
	var thisview = plus.webview.currentWebview(); 
	targetId = thisview.targetId;
	targetType = thisview.targetType;
	document.getElementById("messageName").innerHTML = thisview.targetName; 
	console.log(targetType+"-targetId-"+targetId); 
	if(targetType == 1){ //群聊
		var str = localStorage.getItem("needAvatar");
		if(str != null && str.length > 0){
			needAvatar = JSON.parse(str);			
		}
		str = localStorage.getItem("needNickname");
		if(str != null && str.length > 0){
			needNickname = JSON.parse(str);
		}
	}	
	 
	plus.webview.currentWebview().setStyle({
		softinputMode: "adjustResize"
	});
	var showKeyboard = function() {
		if ($.os.ios) {
			var webView = plus.webview.currentWebview().nativeInstanceObject();
			webView.plusCallMethod({
				"setKeyboardDisplayRequiresUserAction": false
			});
		} else {
			var Context = plus.android.importClass("android.content.Context");
			var InputMethodManager = plus.android.importClass("android.view.inputmethod.InputMethodManager");
			var main = plus.android.runtimeMainActivity();
			var imm = main.getSystemService(Context.INPUT_METHOD_SERVICE);
			imm.toggleSoftInput(0, InputMethodManager.SHOW_FORCED);
			//var view = ((ViewGroup)main.findViewById(android.R.id.content)).getChildAt(0);
			imm.showSoftInput(main.getWindow().getDecorView(), InputMethodManager.SHOW_IMPLICIT);
			//alert("ll");
		}
	};
	/* var record = [{
		sender: 'zs',
		type: 'text',
		content: 'Hi，我是 MUI 小管家！'
	}]; */
	var record = [];
	var ui = {
		body: doc.querySelector('body'),
		footer: doc.querySelector('footer'),
		footerRight: doc.querySelector('.footer-right'),
		footerLeft: doc.querySelector('.footer-left'),
		btnMsgType: doc.querySelector('#msg-type'),
		boxMsgText: doc.querySelector('#msg-text'),
		boxMsgSound: doc.querySelector('#msg-sound'),
		btnMsgImage: doc.querySelector('#msg-image'),
		areaMsgList: doc.querySelector('#msg-list'),
		boxSoundAlert: doc.querySelector('#sound-alert'),
		h: doc.querySelector('#h'),
		content: doc.querySelector('.mui-content')
	};
	ui.h.style.width = ui.boxMsgText.offsetWidth + 'px';
	//alert(ui.boxMsgText.offsetWidth );
	var footerPadding = ui.footer.offsetHeight - ui.boxMsgText.offsetHeight;
	var msgItemTap = function(msgItem, event) {
		var msgType = msgItem.getAttribute('msg-type');
		var msgContent = msgItem.getAttribute('msg-content')
		if (msgType == 'sound') {
			player = plus.audio.createPlayer(msgContent);
			var playState = msgItem.querySelector('.play-state');
			playState.innerText = '正在播放...';
			player.play(function() {
				playState.innerText = '点击播放';
			}, function(e) {
				playState.innerText = '点击播放';
			});
		}
	};
	imageViewer = new $.ImageViewer('.msg-content-image', {
		dbl: false
	});
	var bindMsgList = function() {
		//绑定数据:
		/*tp.bind({
			template: 'msg-template',
			element: 'msg-list',
			model: record
		});*/
		ui.areaMsgList.innerHTML = template('msg-template', {
			"record": record
		});
		var msgItems = ui.areaMsgList.querySelectorAll('.msg-item');
		[].forEach.call(msgItems, function(item, index) {
			item.addEventListener('tap', function(event) {
				msgItemTap(item, event);
			}, false);
		});
		imageViewer.findAllImage();
		setTimeout(function(){
			doc.querySelector('.lodding').style.display = "none";	
			ui.areaMsgList.scrollTop = ui.areaMsgList.scrollHeight + ui.areaMsgList.offsetHeight;
		},500);
	};
	//在这里加载消息记录（找到用户id或群id，即targetId，加载对应的消息记录）
	//如果是获取群消息，必须传group_id	
	// var his_record = function(his) { //统一的发送消息方法
	// 	if(his != null){
	// 		//console.log("his_record->"+JSON.stringify(his));
	// 		for(var i = his.length - 1; i >= 0; i--){
	// 			record.push(his[i]);			
	// 		}
	// 		bindMsgList();
	// 	}
	// };
	//不采用本地消息
	//selectImRecord(targetType, targetId, 0, 100, his_record);
	
	var total_record = null;
	var cur_index = -1;
	var my_avatar = localStorage.getItem("im_avatar");	
	//console.log((my_avatar==null)+"--"+(my_avatar == '')+'-my_avatar:' + my_avatar);	
	if(my_avatar==null || my_avatar == '' || my_avatar == 'null'){
		my_avatar = "../images/my_icon_headPortrait_select@2x.png"; //客户头像	
	}		
	var myName = localStorage.getItem("im_nickname"); 
	var im_id = localStorage.getItem("im_id"); 
	//console.log(myName+'-my_avatar:' + my_avatar);
	 
	var add_record_text = function(targetType, message) { 
		//var message = his_msgs[cur_index];			
		 
		var _avatar = null;
		if(targetType == 1) { 		
			if(needAvatar != null){
				_avatar = needAvatar[message.content.from_id];
				if(_avatar == null || _avatar.length < 5){
					_avatar = "../images/my_icon_headPortrait_select@2x.png"; //客户头像	
				}
			}else{
				_avatar = "../images/my_icon_headPortrait_select@2x.png"; //客户头像	
			}			
		}else {
			_avatar = "./images/customerService_icon_01@2x.png"; //客服头像
		}		
		//console.log("->"+message.content.from_name)
		var _sender = null;
		if(needAvatar != null){
			_sender = needNickname[message.content.from_id];			
		}
		if(_sender == null){
			_sender = message.content.from_name;
		}
		if(message.content.from_id == im_id){
			_avatar = my_avatar;
			_sender = "self";
		}				
		var msg_item = {
			sender: _sender,
			avatar: _avatar,
			type: "text",
			content: message.content.msg_body.text
		}
		record.push(msg_item);	
		//bindMsgList(); 	
		
		add_text_file();
	};	
	
	var add_record_file = function(targetType, message) { 				
		var _avatar = null;
		if(targetType == 1) { 		
			if(needAvatar != null){
				_avatar = needAvatar[message.content.from_id];
				if(_avatar == null || _avatar.length < 5){
					_avatar = "../images/my_icon_headPortrait_select@2x.png"; //客户头像	
				}
			}else{
				_avatar = "../images/my_icon_headPortrait_select@2x.png"; //客户头像	
			}			
		}else {
			_avatar = "./images/customerService_icon_01@2x.png"; //客服头像
		}
		
		var _sender = message.content.from_name;
		if(message.content.from_id == im_id){
			_avatar = my_avatar;
			_sender = "self";
		}	
		var _type = message.content.msg_type;
		if(_type == 'file'){
			_type = 'sound';
		}
		JIM.getResource({'media_id' : message.content.msg_body.media_id})
		.onSuccess(function(data){
			//data.code 返回码
			//data.message 描述
			//data.url 资源临时访问路径，具体超时时间expire time会包含在url中
			//console.log('success:' + JSON.stringify(data));					 
		
			var msg_item = {
				sender: _sender,
				avatar: _avatar,
				type: _type,
				content: data.url
			}
			record.push(msg_item);
			 				
			add_text_file();				
		}).onFail(function(data){
			console.log('error:' + JSON.stringify(data));
			//appendToDashboard('error: ' +JSON.stringify(data));
			var msg_item = {
				sender: _sender,
				avatar: _avatar,//头像
				type: _type,
				content: 'error:'
			}
			record.push(msg_item);
			//bindMsgList(); 
			
			add_text_file();
		});		
	};	
	
	/**
	 * 增加文字或文件消息记录
	 */	
	var add_text_file = function(){		
		if(cur_index < total_record.length-1){
			doc.querySelector('.lodding').style.display = "block";	
			cur_index++;
			var message = total_record[cur_index];
			//console.log("--->"+(message.content==null));
			var _type = message.content.msg_type;
			if(_type == 'text'){
				add_record_text(targetType, message);
			}else {
				add_record_file(targetType, message);
			}
		}else{
			//doc.querySelector('.lodding').style.display = "none";	
			bindMsgList(); 	
		}
	}	
	
	JIM.onSyncConversation(function(data) { //离线消息同步监听
		//data = JSON.stringify(data);
		if(data == null){
			return;
		}
		if(targetType == 1){ //群聊
			for(var i = 0; i < data.length; i++){
				if(data[i].from_gid == targetId){
					total_record = data[i].msgs;
					if(total_record != null && total_record.length > 0){
						add_text_file();
					}					
				}
			} 
		}else {  //单聊
			for(var i = 0; i < data.length; i++){
				if(data[i].from_username == targetId){
					total_record = data[i].msgs;
					//add_record(targetType, his_msgs);
					if(total_record != null && total_record.length > 0){
						add_text_file();
					}
				}
			} 
		}				 
	});
	 
	window.addEventListener('resize', function() {
		ui.areaMsgList.scrollTop = ui.areaMsgList.scrollHeight + ui.areaMsgList.offsetHeight;
	}, false);
	
	var send = function(msg) { //统一的发送消息方法
		record.push(msg);
		bindMsgList();
		
		//发送给极光IM
		jmessage_send(msg);
		
		//toRobot(msg.content);  //发送消息给机器人		
	};
	 
	/**发送
	 * @param {Object} msg
	 */
	var jmessage_send = function(msg) {
		console.log("jmessage_send->"+msg.content);
		if(msg.type == "text") {  //文本
			if(msg.content){
				if(msg.content.length > 255){
					mui.toast("您输入的内容超过250个字了，少点吧!");
					return
				}
				if(targetType == 1){ //群聊
					sendGroupMsg(targetId, msg.content);					
				}else {
					sendSingleMsg(targetId, msg.content);					
				}				
			}											
		}else {	//文件类型
			plus.io.resolveLocalFileSystemURL(msg.content, function (entry) {
			entry.file(function (_file) {
				var reader = new plus.io.FileReader();
				reader.onloadend = function (e) {
					var file=(function (path,name) {
						var arr = path.split(','), mime = arr[0].match(/:(.*?);/)[1],
						bstr = atob(arr[1]), n = bstr.length, u8arr = new Uint8Array(n);
						while (n--) {
							u8arr[n] = bstr.charCodeAt(n);
						}
						return new File([u8arr], name, {type: mime});
					})(e.target.result,entry.name);
					
					var formData = new FormData();
					formData.append(_file.name, file);
				
					if(msg.type == "image"){ //发送图片文件						 
						if(targetType == 1){ //群聊
							sendGroupPic(targetId, formData);	
						}else {
							sendSinglePic(targetId, msg.content);
						}
					}else if(msg.type == "sound"){ //发送语音文件
						if(targetType == 1){ //群聊
							sendGroupFile(targetId, formData);	
						}else {
							sendSingleFile(targetId, msg.content);
						}
					}else{ //发送其他类型
						mui.toast("发送类型不支持");
					}
				};
				reader.readAsDataURL(_file);
			});
			},function (e) {
				mui.toast("文件读取失败");
			});	
		}
		
	}
	
	JIM.onMsgReceive(function(data) { //聊天消息实时监听 消息类型 3-single, 4-group
		console.log('1msg_receive:' + JSON.stringify(data)); 
		jmessage_receive(data);		
	});
	  
	/**接收
	 * @param {Object} msg
	 */
	var message;
	var jmessage_receive = function(msg) {	
		message = msg["messages"][0];
		console.log(message);
		//var messages = msg["messages"];		
		//var data = messages[0];
		if(message.content.msg_type == "text"){
			 
			//保存消息到数据库	
			var _avatar;
			if(message.msg_type == 3){ //单人
				if(message.content.from_id == targetId){
					_avatar = "./images/customerService_icon_01@2x.png"; //客服头像	
					var msg_item = {
						sender: message.content.from_name,
						avatar: _avatar, //头像
						type: 'text',
						content: message.content.msg_body.text
					}
					record.push(msg_item);
					bindMsgList();		
				} 	
			}else {  //群组				
				if(message.content.target_id == targetId){					
					if(needAvatar != null){
						_avatar = needAvatar[message.content.from_id];
						if(_avatar == null || _avatar.length < 5){
							_avatar = "../images/my_icon_headPortrait_select@2x.png"; //客户头像	
						}
					}else{
						_avatar = "../images/my_icon_headPortrait_select@2x.png"; //客户头像	
					}
					 
					var msg_item = {
						sender: message.content.from_name,
						avatar: _avatar, //头像
						type: 'text',
						content: message.content.msg_body.text
					}
					record.push(msg_item);
					bindMsgList();		
				} 	
			}	
		}else { // plus.io.PUBLIC_DOWNLOADS 程序公用下载目录常量
			JIM.getResource({'media_id' : message.content.msg_body.media_id})
			.onSuccess(function(data){
				//data.code 返回码
				//data.message 描述
				//data.url 资源临时访问路径，具体超时时间expire time会包含在url中
				console.log('success:' + JSON.stringify(data));					 
				
				var _type = message.content.msg_type, _avatar;
				if(_type == 'file'){
					_type = 'sound';
				}
			
				if(message.msg_type == 3){ 	 //单人				
					_avatar = "./images/customerService_icon_01@2x.png"; //客服头像		
					
					if(message.content.from_id == targetId){
						var msg_item = {
							sender: message.content.from_name,
							avatar: _avatar, //头像
							type: _type,
							content: data.url
						}
						record.push(msg_item);
						bindMsgList();	
					} 		
				}else {					
					if(message.content.target_id == targetId){
						if(needAvatar != null){
							_avatar = needAvatar[message.content.from_id];
							if(_avatar == null || _avatar.length < 5){
								_avatar = "../images/my_icon_headPortrait_select@2x.png"; //客户头像	
							}
						}else{
							_avatar = "../images/my_icon_headPortrait_select@2x.png"; //客户头像	
						}
						
						var msg_item = {
							sender: message.content.from_name,
							avatar: _avatar, //头像
							type: _type,
							content: data.url
						}
						record.push(msg_item);
						bindMsgList();	
					} 	
				}					
			}).onFail(function(data){
				console.log('error:' + JSON.stringify(data));			
			});
		}			 
	}

	function msgTextFocus() {
			ui.boxMsgText.focus();
			setTimeout(function() {
				ui.boxMsgText.focus();
			}, 150);
		}
		//解决长按“发送”按钮，导致键盘关闭的问题；
	ui.footerRight.addEventListener('touchstart', function(event) {
		if (ui.btnMsgType.classList.contains('mui-icon-paperplane')) {
			msgTextFocus();
			event.preventDefault();
		}
	});
	//解决长按“发送”按钮，导致键盘关闭的问题；
	ui.footerRight.addEventListener('touchmove', function(event) {
		if (ui.btnMsgType.classList.contains('mui-icon-paperplane')) {
			msgTextFocus();
			event.preventDefault();
		}
	});
	 
	ui.footerRight.addEventListener('release', function(event) {
		if (ui.btnMsgType.classList.contains('mui-icon-paperplane')) {
			//showKeyboard();
			ui.boxMsgText.focus();
			setTimeout(function() {
				ui.boxMsgText.focus();
			}, 450);
		 
			send({
				avatar: my_avatar,
				sender: 'self',
				type: 'text',
				content: ui.boxMsgText.value.replace(new RegExp('\n', 'gm'), '<br/>')
			});
			ui.boxMsgText.value = '';
			$.trigger(ui.boxMsgText, 'input', null);
		} else if (ui.btnMsgType.classList.contains('mui-icon-mic')) {
			ui.btnMsgType.classList.add('mui-icon-compose');
			ui.btnMsgType.classList.remove('mui-icon-mic');
			ui.boxMsgText.style.display = 'none';
			ui.boxMsgSound.style.display = 'block';
			ui.boxMsgText.blur();
			document.body.focus();
		} else if (ui.btnMsgType.classList.contains('mui-icon-compose')) {
			ui.btnMsgType.classList.add('mui-icon-mic');
			ui.btnMsgType.classList.remove('mui-icon-compose');
			ui.boxMsgSound.style.display = 'none';
			ui.boxMsgText.style.display = 'block';
			//--
			//showKeyboard();
			ui.boxMsgText.focus();
			setTimeout(function() {
				ui.boxMsgText.focus();
			}, 150);
		}
	}, false);
	//发送图片
	ui.footerLeft.addEventListener('tap', function(event) { 
		var btnArray = [{
			title: "拍照"
		}, {
			title: "从相册选择"
		}];
		plus.nativeUI.actionSheet({
			title: "选择照片",
			cancel: "取消",
			buttons: btnArray
		}, function(e) {
			var index = e.index;
			switch (index) {
				case 0:
					break;
				case 1:
					var cmr = plus.camera.getCamera();
					cmr.captureImage(function(path) {
						send({
							avatar:my_avatar,
							sender: 'self',
							type: 'image',
							content: "file://" + plus.io.convertLocalFileSystemURL(path)
						});
					}, function(err) {});
					break;
				case 2:
					plus.gallery.pick(function(path) {
						send({
							avatar:my_avatar,
							sender: 'self',
							type: 'image',
							content: path
						});
					}, function(err) {}, null);
					break;
			}
		});
	}, false); 
	var setSoundAlertVisable=function(show){
		if(show){
			ui.boxSoundAlert.style.display = 'block';
			ui.boxSoundAlert.style.opacity = 1;
		}else{
			ui.boxSoundAlert.style.opacity = 0;
			//fadeOut 完成再真正隐藏
			setTimeout(function(){
				ui.boxSoundAlert.style.display = 'none';
			},200);
		}
	};
	var recordCancel = false;
	var recorder = null;
	var audio_tips = document.getElementById("audio_tips");
	var startTimestamp = null;
	var stopTimestamp = null;
	var stopTimer = null;
	//发送语音
	ui.boxMsgSound.addEventListener('hold', function(event) {
		recordCancel = false;
		if(stopTimer)clearTimeout(stopTimer);
		audio_tips.innerHTML = "手指上划，取消发送";
		ui.boxSoundAlert.classList.remove('rprogress-sigh');
		setSoundAlertVisable(true);
		recorder = plus.audio.getRecorder();
		if (recorder == null) {
			plus.nativeUI.toast("不能获取录音对象");
			return;
		}
		startTimestamp = (new Date()).getTime();
		recorder.record({
			filename: "_doc/audio/"
		}, function(path) {
			if (recordCancel) return;
			send({
				avatar:my_avatar,
				sender: 'self',
				type: 'sound',
				content: path
			});
		}, function(e) {
			plus.nativeUI.toast("录音时出现异常: " + e.message);
		});
	}, false);
	ui.body.addEventListener('drag', function(event) {
		//console.log('drag');
		if (Math.abs(event.detail.deltaY) > 50) {
			if (!recordCancel) {
				recordCancel = true;
				if (!audio_tips.classList.contains("cancel")) {
					audio_tips.classList.add("cancel");
				}
				audio_tips.innerHTML = "松开手指，取消发送";
			}
		} else {
			if (recordCancel) {
				recordCancel = false;
				if (audio_tips.classList.contains("cancel")) {
					audio_tips.classList.remove("cancel");
				}
				audio_tips.innerHTML = "手指上划，取消发送";
			}
		}
	}, false);
	ui.boxMsgSound.addEventListener('release', function(event) {
		//console.log('release');
		if (audio_tips.classList.contains("cancel")) {
			audio_tips.classList.remove("cancel");
			audio_tips.innerHTML = "手指上划，取消发送";
		}
		//
		stopTimestamp = (new Date()).getTime();
		if (stopTimestamp - startTimestamp < MIN_SOUND_TIME) {
			audio_tips.innerHTML = "录音时间太短";
			ui.boxSoundAlert.classList.add('rprogress-sigh');
			recordCancel = true;
			stopTimer=setTimeout(function(){
				setSoundAlertVisable(false);
			},800);
		}else{
			setSoundAlertVisable(false);
		}
		recorder.stop();
	}, false);
	ui.boxMsgSound.addEventListener("touchstart", function(e) {
		//console.log("start....");
		e.preventDefault();
	});
	ui.boxMsgText.addEventListener('input', function(event) {
		ui.btnMsgType.classList[ui.boxMsgText.value == '' ? 'remove' : 'add']('mui-icon-paperplane');
		ui.btnMsgType.setAttribute("for", ui.boxMsgText.value == '' ? '' : 'msg-text');
		ui.h.innerText = ui.boxMsgText.value.replace(new RegExp('\n', 'gm'), '\n-') || '-';
		ui.footer.style.height = (ui.h.offsetHeight + footerPadding) + 'px';
		ui.content.style.paddingBottom = ui.footer.style.height;
	});
	var focus = false;
//	ui.boxMsgText.addEventListener('tap', function(event) {
	ui.boxMsgText.addEventListener('focus', function(event) {  // 若点击输入框有问题 注释本行然后打开上一行注释即可
		//return false;
		ui.boxMsgText.focus();
		setTimeout(function() {
			ui.boxMsgText.focus();
		}, 0);
		focus = true;
		setTimeout(function () {
			focus = false;
		},1000);
		event.detail.gesture.preventDefault();
	}, false);
	//点击消息列表，关闭键盘
	ui.areaMsgList.addEventListener('click',function (event) {
		if(!focus){
			ui.boxMsgText.blur();
		}
	})
	
});
}(mui, document));