mui.init({
	pullRefresh : {
	    container:"#main",//下拉刷新容器标识，querySelector能定位的css选择器均可，比如：id、.class等
	    down : {
	      height:50,//可选,默认50.触发下拉刷新拖动距离,
	      auto: true,//可选,默认false.首次加载自动下拉刷新一次
	      contentdown : "创造财富",//可选，在下拉可刷新状态时，下拉刷新控件上显示的标题内容
	      contentover : "从金开始",//可选，在释放可刷新状态时，下拉刷新控件上显示的标题内容
	      contentrefresh : "正在刷新...",//可选，正在刷新状态时，下拉刷新控件上显示的标题内容
	      callback :enterPlan //必选，刷新函数，根据具体业务来编写，比如通过ajax从服务器获取新数据；
	    }
	},
	swipeBack: true
});

var planId;
var isRefresh = false;

var txImg = localStorage.getItem("loginImg");
if(txImg){
	$("#txImg").attr("src",txImg);
}

//获取最近一场完成的投资计划，返回的是主计划，那着主计划的计划期号去获取计划的阶段getRunningState
function enterPlan(){
	var ticket = localStorage.getItem("ticket");
	var url =  urlPre + "trade/enterPlan";
	mui.ajax(url,{
    	data:{
    		ticket:ticket,
		},
	    dataType:'json',
	    type:'get',
	    timeout:20000,
		success:function(res){
			var data = res.data;
			if(!data){
				hasNewPlan();
			}
			if(res.code == 224){
				//mui.toast("计划进行中");
				getRunningState(res.data.id);
			}else if(res.code == 225){
				//mui.toast("开启新计划");
			}else if(res.code == 228){
				//mui.toast("完成计划");
			}
			var state = "";
			if(data.state == 1){
				state = "进行中";
			}else if(data.state == 2){
				state = "结束";
			}
			var type = typeCheck(data.type);
			data.profitAbility = decimal(data.profitAbility,2);
			
			var createTime = dates(data.createTime);
			var endTime = dates(data.endTime);
			$("#total-state").html(state);
			$("#total-date").html(createTime);
			$("#total-profit").html(data.profit);
			$("#total-money").html(data.capital);
			$("#total-type").html(type);
			$("#total-num").html(data.position);
			$("#total-avgPrice").html(data.avgPrice);
			$("#end-date").html(endTime);
			
			data.profitAbility = decimal(data.profitAbility,2);
			data.profitAbility = floatCompletion(data.profitAbility);
			
			$("#total-profitAbility").html(data.profitAbility+"%");
			
			var total_profit = $("#total-profit").html();
			if(total_profit < 0){
				$("#total-profit").removeClass("riseColor");
				$("#total-profit").addClass("fallColor");
				
				$("#total-profitAbility").removeClass("riseColor");
				$("#total-profitAbility").addClass("fallColor");
			}else if(total_profit > 0){
				$("#total-profit").removeClass("fallColor");
				$("#total-profit").addClass("riseColor");
				
				$("#total-profitAbility").removeClass("fallColor");
				$("#total-profitAbility").addClass("riseColor");
			}else{
				$("#total-profit").css({"color":"#fff"});
				$("#total-profitAbility").css({"color":"#fff"});
			}
			
		},
		error: function(){
			mui.toast("请求失败");
			isRefresh = true;
			mui('#main').pullRefresh().endPulldownToRefresh(); //refresh completed
		}
	});
}


$('.content').on("tap",".item",function(){
	if($(this).hasClass("narrow")){
		$(this).removeClass("narrow");
		$(this).find(".mui-icon").removeClass("mui-icon-arrowdown");
		$(this).find(".mui-icon").addClass("mui-icon-arrowup");
	}else{
		$(this).addClass("narrow");
		$(this).find(".mui-icon").removeClass("mui-icon-arrowup");
		$(this).find(".mui-icon").addClass("mui-icon-arrowdown");
	}
});

// 获取投资计划详情
function getRunningState(planId){
	var ticket = localStorage.getItem("ticket");
	var url =  urlPre + "trade/getRunningState";
	mui.ajax(url,{
    	data:{
    		ticket:ticket,
    		planSeq:planId
		},
	    dataType:'json',
	    type:'get',
	    timeout:20000,
		success:function(res){
			console.log("下拉完成");
			if(isRefresh){
				setTimeout(function(){
					mui('#main').pullRefresh().endPulldownToRefresh();
				},500);
			}else{
				mui('#main').pullRefresh().endPulldownToRefresh();
			}
			isRefresh = true;
			if(res.code == 200){
				if(res.data.length <= 0){ // 未开始
					$(".noMarket").show();
					$("#planStage").html("");
					return false;
				}else{
					$(".noMarket").hide();
					//speed = 3000;
				}
				showRunningState(res.data);
			}
		},
		error:function(res){
			mui.toast("请求失败");
			isRefresh = true;
			mui('#main').pullRefresh().endPulldownToRefresh(); //refresh completed
			//alert("请求失败");
		}
	});
}

function showRunningState(data){
	$("#planStage").html("");
	$.each(data, function(key,value) {
		var _date = dates(value.createTime);
		var state = "";
		var profit = "--";
		var blueColor = "";
		var stage = "";
		var w35 = "";
		var w15 = "";
		var narrow = "";
		var icon = "",finish = "";
		var priceRemark = "操作价位";
		if(value.state == 0){
			state = "进行中";  // 待扫描或者进行中，需要确认
			blueColor = "blue";
			if(value.planSeqState == 1){
				state = "未开市";
			}
		}else if(value.state == 1){
			state = "已完成";
			narrow = "narrow";
			priceRemark = "成交价格";
			icon = '<span class="mui-icon mui-icon-arrowdown F9AD52"></span>';
			finish = "finish";
		}
		if(isEmpty(value.profit)){
			profit = value.profit;
		}
		
		if(value.planSeqState == 1){
			stage = "阶段一";
		}else if(value.planSeqState == 2){
			stage = "阶段二";
		}else if(value.planSeqState == 3){
			stage = "阶段三";
		}else if(value.planSeqState == 4){
			stage = "阶段四";
		}
		
	
		var stagePrice = '';
		if(value.state != 1){
			value.downPrice = decimal(value.downPrice,2);
			value.upPrice = decimal(value.upPrice,2);
			
			if(value.type != 0){
				value.downPrice = floatCompletion(value.downPrice);
				value.upPrice = floatCompletion(value.upPrice);
			}
			
			stagePrice = '<li class="w35"><span><i class="orange" id="three-upPrice">'+value.downPrice+'</i><em style="color: #282828; padding: 0 0.03rem;">或</em><i class="orange" id="three-downPrice">'+value.upPrice+'</i></span></li>';
			w35 = "w35";
			w15 = "w15";
		}else{
			if(value.dealPrice == 0){
				value.dealPrice = "-";
			}
			value.dealPrice = decimal(value.dealPrice,2);
			if(value.type != 0){
				value.dealPrice = floatCompletion(value.dealPrice);
			}
			stagePrice = '<li><span class="orange" >'+value.dealPrice+'</span></li>';
		}

		var html = '<div class="item three '+narrow+'">\
		    		<div class="item-t c">\
		    			<ul>\
		    				<li class="orange" id="three-stage">'+stage+'</li>\
		    				<li>日期:<span id="three-date">'+_date+'</span></li>\
		    				<li class="'+blueColor+'" id="three-state"></li>\
		    				<li class="'+blueColor+finish+'">'+state+icon+'</li>\
		    			</ul>\
		    		</div>\
		    		<div class="item-c c">\
		    			<ul>\
		    				<li class="'+w35+'">'+priceRemark+'</li>\
		    				<li>操作方向</li>\
		    				<li class="'+w15+'">操作手数</li>\
		    				<li>盈亏</li>\
		    			</ul>\
		    		</div>\
		    		<div class="item-b c">\
		    			<ul>'+stagePrice+'<li id="three-direction">'+directionCheck(value.direction)+'</li>\
		    				<li id="three-num" class="'+w15+'">'+value.num+'</li>\
		    				<li id="three-profit">'+profit+'</li>\
		    			</ul>\
		    		</div>\
		    	</div>';
		$("#planStage").prepend(html);
	});
}


// 是否有新计划
function hasNewPlan(){
	var ticket = localStorage.getItem("ticket");
	var url =  urlPre + "trade/hasNewPlan";
	mui.ajax(url,{
    	data:{
    		ticket:ticket,
		},
	    dataType:'json',
	    type:'get',
	    timeout:20000,
		success:function(res){
			console.log(res.code);
			if(res.code == 225){
				//plus.webview.open("setPlan.html", 'new', {}, 'slide-in-right', 200);
			}else if(res.code == 226){
				resCodeTips(res.code);
			}else {
				resCodeTips(res.code);
			}
		}
	});
}
function his(){
	//location.href = "planEnd.html?history=1";
	plus.webview.open("planEnd.html?history=1", 'new', {}, 'slide-in-right', 200);
}

var client_id = localStorage.getItem("client_id");
if(!client_id){
	// 检测到该账号是未绑定交易账户
	$(".b-banner").show();
}
